﻿using HeuristicLab.Clients.Hive.WebJobManager.Services;
using HeuristicLab.Common;
using Microsoft.AspNet.SignalR;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;

namespace HeuristicLab.Clients.Hive.WebJobManager
{
    public class JobUpdaterHub : Hub
    {
        
        private RefreshableJob Job;
     

        public void initConnection()
        {
            FileOpeningService.Instance.previousids = new List<Guid>();
            FileOpeningService.Instance.previousLogs = new List<int>();
            Job = FileOpeningService.Instance.Job;
            updateAll();

        }
        public void updateAll()
        {
            FileOpeningService.Instance.refreshJob();
            Job = FileOpeningService.Instance.Job;

            foreach (var t in Job.HiveTasks)
            {
                looperTasks(t);
            }
            Clients.All.requestDone();

        }
        private void looperTasks(HiveTask task)
        {
            try
            {
                int index;
                bool test = false;
                if (FileOpeningService.Instance.previousids.Contains(task.Task.Id))
                {
                    index = FileOpeningService.Instance.previousids.IndexOf(task.Task.Id);
                }
                else
                {
                    FileOpeningService.Instance.previousids.Add(task.Task.Id);
                    index = FileOpeningService.Instance.previousids.IndexOf(task.Task.Id);
                    FileOpeningService.Instance.previousLogs.Add(task.Task.StateLog.Count);
                    test = true;
                }
                var previous = FileOpeningService.Instance.previousLogs[index];
                if (test || previous < task.Task.StateLog.Count)
                {
                    FileOpeningService.Instance.previousLogs[index] = task.Task.StateLog.Count;
                    JsonSerializerSettings settings = new JsonSerializerSettings();
                    settings.ContractResolver = new JsonTaskResolver();
                    var json = JsonConvert.SerializeObject(task.Task, settings);
                    Clients.All.processData(task.Task.Id, json);
                }
                foreach (var t in task.ChildHiveTasks)
                {
                    looperTasks(t);
                }
            }
            catch (JsonSerializationException e) { }
        }
    }
}
