﻿using HeuristicLab.Clients.Hive.WebJobManager.Services;
using HeuristicLab.Optimization;
using Microsoft.AspNet.SignalR;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace HeuristicLab.Clients.Hive.WebJobManager
{
    public class ProgressHub : Hub
    {
        private RefreshableJob Job;
        public void HandleMessage(string receivedString)
        {

            Clients.All.processMessage("Connection Established");
            Job = FileOpeningService.Instance.Job;
            Job.Progress.StatusChanged += runHub;
        }
        public void ChangeName(string name)
        {
            if (name != null)
                FileOpeningService.Instance.Job.Job.Name = name;
        }
        public void ToggleChild(int[][] arr)
        {
            Job = FileOpeningService.Instance.Job;
            HiveTask current = Job.HiveTasks.ToList()[0];
            //  IOptimizer current = Job.HiveTasks.ToArray() ;
            if (arr.Length == 0)
            {
                current.ItemTask.ComputeInParallel = !current.ItemTask.ComputeInParallel;
                
            }
            else {
                for (var i = 0; i < arr.Length; i++)
                {


                    if (i == arr.Length - 1)
                    {
                        if (current.ItemTask.Item is BatchRun)
                        {
                            current.ChildHiveTasks[arr[i][1]].ItemTask.ComputeInParallel = !current.ChildHiveTasks[arr[i][1]].ItemTask.ComputeInParallel;
                        }
                        else if (current.ItemTask.Item is Experiment)
                        {
                            current.ChildHiveTasks[arr[i][0]].ItemTask.ComputeInParallel = !current.ChildHiveTasks[arr[i][0]].ItemTask.ComputeInParallel;
                        }

                    }
                    else {
                        if (current.ItemTask.Item is BatchRun)
                            current = current.ChildHiveTasks[arr[i][1]]; // select right batch
                        else if (current.ItemTask.Item is Experiment)
                            current = current.ChildHiveTasks[arr[i][0]]; // select right sub task from experiment
                    }
                }
            }
        }
        public void ChangePriority(int[][] arr, int prior)
        {
            Job = FileOpeningService.Instance.Job;
            HiveTask current = Job.HiveTasks.ToList()[0];
            //  IOptimizer current = Job.HiveTasks.ToArray() ;
            if (arr.Length == 0)
            {
                current.Task.Priority = prior;

            }
            else {
                for (var i = 0; i < arr.Length; i++)
                {


                    if (i == arr.Length - 1)
                    {
                        if (current.ItemTask.Item is BatchRun)
                        {
                            current.ChildHiveTasks[arr[i][1]].Task.Priority = prior;
                        }
                        else if (current.ItemTask.Item is Experiment)
                        {
                            current.ChildHiveTasks[arr[i][0]].Task.Priority = prior;
                        }

                    }
                    else {
                        if (current.ItemTask.Item is BatchRun)
                            current = current.ChildHiveTasks[arr[i][1]]; // select right batch
                        else if (current.ItemTask.Item is Experiment)
                            current = current.ChildHiveTasks[arr[i][0]]; // select right sub task from experiment
                    }
                }
            }
        }
        public void runHub(object sender, EventArgs e)
        {
            int value = 0;

            switch (Job.Progress.Status)
            {
                case "Connecting to server...":
                    value = 0;
                    break;
                case "Uploading Job...":
                    value = 10;
                    break;
                case "Uploading plugins...":
                    value = 30;
                    break;
                case "Uploading tasks...":
                    value = 50;
                    break;
                case "Upload finished":
                    value = 100;
                    break;
                default:
                    value = (int)(50 + (40 * Job.Progress.ProgressValue));//steps
                    break;

            }

            Clients.All.processMessage(Job.Progress.Status, value);

        }

    }
}
