﻿var dataCollection = [];

function initSaveData(id, coll) {//initial data save
    var temp = dataConversion(coll);
    temp.unshift(id); //add ID in front of array
    dataCollection.push(temp);// [id,timearr, piearr]
    console.log("#CREATION: " + id);
}
function saveData(id, coll) {
    var temp = dataConversion(coll);
    for (var i = 0; i < dataCollection.length; i++) {
        if (dataCollection[i][0] == id) {
            dataCollection[i][1] = temp[0];
            dataCollection[i][2] = temp[1];
        }
    }
    //console.log("#SAVEDATA: " + id);
    redrawGraph(id);
}
function getData(id) {
    for (var i = 0; i < dataCollection.length; i++) {
        if (dataCollection[i][0] == id) {
            return dataCollection[i][1];
        }
    }
}
function getDataPie(id) {
    for (var i = 0; i < dataCollection.length; i++) {
        if (dataCollection[i][0] == id) {
            return dataCollection[i][2];
        }
    }

}
function dataConversion(coll) {
    
    
    return [dataConversionLine(coll),dataConversionPie(coll)];
}
function dataConversionLine(coll) {
    var xarr = [];
    var yarr = [];
    for (var v = 0; v < coll.length; v++) {
        xarr.push(Date.parse(coll[v].DateTime));
        if (coll[v].State == 1)
            yarr.push("Waiting");
        else if (coll[v].State == 2) 
            yarr.push("Transferring");
        else if (coll[v].State == 3) 
            yarr.push("Calculating");
        else if (coll[v].State == 5)
            yarr.push("Finished");
        else if (coll[v].State == 7)
            yarr.push("Failed");
    }
    var data = [{//Time graph
        x: xarr,
        y: yarr,
        type: 'scatter',
        mode: 'lines',
        name: 'Task ' ,
        connectgaps:true,
        line:{shape:'hv'}
    }];
    layout= {
        "showlegend": true,
        "width": "100%",
        "xaxis": {
            "autorange": true, 
            "range": [
                Date.parse(coll[0].DateTime), 
                Date.parse(coll[coll.length -1].DateTime)
            ], 
            "title": "Time", 
            "type": "date"
        }

    }
    
    return [data,layout];
}
function dataConversionHBar(coll) {
    var xarr = [];
    var yarr = [];
    for (var v = 0; v < coll.length; v++) {
        xarr.push(coll[v].DateTime.substr(11, 8));
        if (coll[v].State == 1)
            yarr.push("Waiting");
        else if (coll[v].State == 2) 
            yarr.push("Transferring");
        else if (coll[v].State == 3) 
            yarr.push("Calculating");
        else if (coll[v].State == 5)
            yarr.push("Finished");
        else if (coll[v].State == 7)
            yarr.push("Failed");
    }
    var data = [{//Time graph
        x: xarr,
        y: yarr,
        type: 'scatter'
    }];
    
    return data;
}
function dataConversionPie(coll) {
    var waiting = 0;
    var transfer = 0;
    var calc = 0;
    for (var v = 0; v < coll.length-1; v++) {
        if(coll[v].State == 1)
            waiting += Date.parse(coll[v + 1].DateTime) - Date.parse(coll[v].DateTime);
        else if (coll[v].State == 2) 
            transfer += Date.parse(coll[v + 1].DateTime) - Date.parse(coll[v].DateTime);
        else if (coll[v].State == 3) 
            calc += Date.parse(coll[v + 1].DateTime) - Date.parse(coll[v].DateTime);
    }
    var datap = [{//Pie graph
        values: [
            Math.round(waiting / 1000 / 60),
            Math.round(transfer / 1000 / 60),
            Math.round(calc / 1000 / 60)],
        labels: [
            'Minutes waiting',
            'Minutes transferring',
            'Minutes calculating'],
        type: 'pie'
    }];
    return datap;
}

function redrawGraph(val) {
    document.getElementById("graph" + val).style.width = "100%";
    document.getElementById("graph" + val).style.height = "400px";
    if (document.getElementById("graphtoggle" + val).checked) {
        setTimeout(function () {
            Plotly.newPlot('graph' + val, getData(val)[0], getData(val)[1]);
        }, 100);
        console.log("#REDRAWN LINE: " + val);
    } else {
        setTimeout(function () {
            Plotly.newPlot('graph' + val, getDataPie(val));
        }, 100);
        //console.log("#REDRAWN PIE: " + val);
    }
    

}
function redrawMain() {
    var temp = [];
    var min = dataCollection[0][1][0][0].x[0];
    var max = min;
    for (var i = 0; i < dataCollection.length; i++) {
        temp.push(dataCollection[i][1][0][0]);
        if (dataCollection[i][1][0][0].x[dataCollection[i][1][0][0].x.length - 1] > max)
            max = dataCollection[i][1][0][0].x[dataCollection[i][1][0][0].x.length - 1];
        if (dataCollection[i][1][0][0].x[0] < min)
            min = dataCollection[i][1][0][0].x[0];
    }
    layout = {
        "showlegend": true,
        "title": new Date(min).toUTCString() + " to " + new Date(max).toUTCString(),
        "xaxis": {
            "autorange": true,
            "range": [
                min,
                max
            ],
            "title": "Time",
            "type": "date"
        }

    }
     Plotly.newPlot('graphMain', temp, layout);


}